(ns ^:figwheel-always gowest.core
    (:require-macros [cljs.core.async.macros :refer [go]])
    (:require [reagent.core :as reagent :refer [atom]]
              [cljs.core.async :refer [<! timeout]]))

(enable-console-print!)

(println "Edits to this text should show up in your developer console.")

;; define your app data so that it doesn't get over-written on reload

(defonce app-state (atom {:text "Hello world!"}))

(defn hello-world []
  [:div
   [:h1 (:text @app-state)]
   [:button
    {:on-click
     (fn [e]
       (swap! app-state assoc :thinking true :thinking-deeply 5)
       (go
         (while (pos? (:thinking-deeply @app-state))
           ;(<! (timeout 2000))
           (apply * (rest (range 10000000)))
           ;(<! (timeout 1))
           (swap! app-state update :thinking-deeply dec))
         (swap! app-state dissoc :thinking :thinking-deeply)))}
    "The button!"]
   (when (:thinking-deeply @app-state)
     [:h2 "Thinking deeply " (:thinking-deeply @app-state)])
   (when (:thinking @app-state)
     [:h2 "Thinking"])
   [:button "The other button"]])

(reagent/render-component [hello-world]
                          (. js/document (getElementById "app")))


(defn on-js-reload []
  ;; optionally touch your app-state to force rerendering depending on
  ;; your application
  ;; (swap! app-state update-in [:__figwheel_counter] inc)
  )
